# CtiLib Usage investigation
### ConfigManager(own CtiLink)
* CtiMessage -> Forward to ConfigDispatcher
* AgentStatusUpdate -> Forward AgentQueues to AgentManager
* IpbxCommandResponse -> Convert error in AgentLoginError (AgentError.create) and forwarded to AgentActionService

### ConfigDispatcher
* AgentConfigUpdate (Same as xuc case class !) -> Ignored
* QueueConfigUpdate (Sames as xuc case class !) -> Ignored
* PhoneConfigUpdate -> Triggers reload of user associated with phone, Triggered when ???
* QueueStatistics -> Computed in StatUpdate and sent to StatsAggregator
* DirectoryResult -> Enrich and sent to sender (
* MeetmeUpdate -> publish on event bus MeetMeList
* In **ConfigInitializer**
  * UsersAdded -> for each user, request PhoneStatus from CtiLink
  * IdsList -> 
    * PhoneIdsList   -> for each id send GetPhoneConfig to CtiLink
    * UserIdsList    -> for each id send GetUserConfig to CtiLink
    * QueueIds       -> for each id send GetQueueConfig to CtiLink
    * QueueMemberIds -> for each id send GetQueueMemberconfig to CtiLink
    
  * UserConfigUpdate -> when received, do
    * Reload user from DB
    * Reload agent from DB
    * ReLoad user line from DB 
    * send GetUserStatus to CtiLink

### AgentManager
* AgentQueues -> Forward to AgentStateFSM

### AgentStateFSM
* AgentQueues -> Store queues membership

### AgentAction
* AgentLoginRequest  -> send AgentLogin to CtiLink
* AgentLogoutRequest -> send AgentLogout to CtiLink
* AgentTogglePause   -> sens Pause/UnpauseAgent to CtiLink

### CtiUserAction
* UncForward  -> send UnconditionnalForward to CtiLink
* NaForward   -> send NaForward to CtiLink
* BusyForward -> send BusyFForward to CtiLink
* Status -> CtiLink
* DND -> CtiLink

### CtiRouter(own CtiLink): TODO
* DirectoryResult -> Forwarded to ConfigDispatcher to be enriched
* IpbxCommandResponse -> Forwarded to agentActionService
* CtiMessage -> Forwarded to CtiFilter
* QueueStatisticsReq(Xuc, from browser) converted to QueueStatRequest and sent to ctiLink 
* InviteConferenceRoom(xuc, from browser) deprecated in favor of new impl
* UserActionRequest(xuc, from browser for status, forwards & DND) -> send to CtiUserAction

### CtiFilter
* When logging in or connecting to a new websocket, request UserConfigUpdate from CtiLink through CtiRouter
* Sheet received from CtiLink
* UserConfigUpdate received from CtiLink -> Update DND & Forward informations and send to Websocket
* PhoneStatusUpdate generated by ConfigDispatcher now, can be replaced by own implementation (see https://projects.xivo.solutions/issues/3654)
* QueueStatistics 
* UserStatusUpdateReq(xuc, brower) sent to CtiRouter

### Websocket events
 * UserStatus
 * Sheet
 * QueueStatistics
 * UserStatusUpdate ?
 * UserConfigUpdate 
 * MeetMe
 * IpbxCommandResponse, received from AgentAction
 

# xivo-ctid feature usage overview

## Agent

Agent status event is only used to extract queues information and can be replaced by ConfigRepository Internal DB.

However we still need to handle login/logout & pause.

## User reloading 

The PhoneConfigUpdate and UserConfigUpdate events trigger some information reload. It can probably be removed and replaced by listening to the correct RabbitMQ events.

## User Presence Status (UserStatus)

Client browser can request to change user status and Ctid update it and report back new status.

Is it still usefull ?

## User forward & DND

How to replace ? Update the database through configmgt ? Triggers rabbit mq event ?

## Directory

Is already replaced by dird direct access.

## Meetme (conferences)

Listing conferences can be obtained through the new conference tracker.
Inviting someone in a conference can be done with new api. Can we deprecate this one ?

## Queues & members information

Theses informations are used to load Queues & queue memberships at startup and mixed up with other services.

## Queue statistics

We need to investigate how these stats are computed in xivo-ctid

## Sheet event

Can probably be generated by the current call tracking mechanism if we load the sheet configuration in Xuc.

## Cleanup

Replace remaining class used to exchange message with `case class` from xuc directly
